Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/services/stakeholder.service.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/services/stakeholder.service.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/services/stakeholder.service.ts	(revision 57697)
@@ -71,9 +71,11 @@
     return this.http.delete<any>(url + '/' + path.join('/') + '/delete');
   }
 
-  reorderIndicators(url: string, path: string[], indicators: Indicator[], type: string = 'chart'): Observable<boolean> {
+  reorderIndicators(url: string, path: string[], indicatorIds: string[], type: string = 'chart'): Observable<Indicator[]> {
     path = HelperFunctions.encodeArray(path);
-    return this.http.post<boolean>(url + '/' + path.join('/') + '/' + type + '/reorder', indicators);
+    return this.http.post<Indicator[]>(url + '/' + path.join('/') + '/' + type + '/reorder', indicatorIds).pipe(map(indicators => {
+      return this.formalize(indicators);
+    }));
   }
 
   getStakeholderAsObservable(): Observable<Stakeholder> {
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/home/home.module.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/home/home.module.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/home/home.module.ts	(revision 57697)
@@ -9,12 +9,12 @@
 import {HomeRoutingModule} from "./home-routing.module";
 import {ModalModule} from "../openaireLibrary/utils/modal/modal.module";
 import {RouterModule} from "@angular/router";
-import {FormsModule} from "@angular/forms";
+import {FormsModule, ReactiveFormsModule} from "@angular/forms";
 import {AlertModalModule} from "../openaireLibrary/utils/modal/alertModal.module";
 
 @NgModule({
   imports: [
-    CommonModule, HomeRoutingModule, ModalModule, RouterModule, FormsModule, AlertModalModule
+    CommonModule, HomeRoutingModule, ModalModule, RouterModule, FormsModule, AlertModalModule, ReactiveFormsModule
   ],
   declarations: [
     HomeComponent
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/home/home.component.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/home/home.component.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/home/home.component.ts	(revision 57697)
@@ -11,6 +11,7 @@
 import {HelperFunctions} from "../openaireLibrary/utils/HelperFunctions.class";
 import {AlertModal} from "../openaireLibrary/utils/modal/alert";
 import {Subscriber} from "rxjs";
+import {FormBuilder, FormGroup, Validators} from "@angular/forms";
 
 declare var UIkit;
 
@@ -25,8 +26,7 @@
   public stakeholder: Stakeholder;
   public analysisOpen: boolean = true;
   private errorMessages: ErrorMessagesComponent;
-  public copyTopic: Topic;
-  public valid = true;
+  public topicFb: FormGroup;
   public element: any;
   public index: number;
   properties: EnvProperties;
@@ -38,6 +38,7 @@
     private router: Router,
     private title: Title,
     private sideBarService: SideBarService,
+    private fb: FormBuilder,
     private stakeholderService: StakeholderService) {
     this.errorCodes = new ErrorCodes();
     this.errorMessages = new ErrorMessagesComponent();
@@ -50,7 +51,7 @@
         this.subscriptions.push(this.stakeholderService.getStakeholderAsObservable().subscribe(stakeholder => {
           if (stakeholder) {
             this.stakeholder = HelperFunctions.copy(stakeholder);
-            this.copyTopic = null;
+            this.topicFb = null;
             this.title.setTitle(stakeholder.index_name);
           }
         }));
@@ -70,7 +71,6 @@
   }
 
   public hide(element) {
-    this.valid = true;
     UIkit.drop(element).hide();
   }
 
@@ -86,14 +86,27 @@
     }
   }
 
+  private buildTopic(topic: Topic) {
+    this.topicFb = this.fb.group({
+      _id: this.fb.control(topic._id),
+      name: this.fb.control(topic.name, Validators.required),
+      description: this.fb.control(topic.description),
+      alias: this.fb.control(topic.alias),
+      isActive: this.fb.control(topic.isActive),
+      isPublic: this.fb.control(topic.isPublic),
+      isDefault: this.fb.control(topic.isDefault),
+      categories: this.fb.control(topic.categories)
+    });
+  }
+
   public saveTopicOpen(element, index = -1) {
     if (element.className.indexOf('uk-open') !== -1) {
       this.hide(element);
     } else {
       if (index === -1) {
-        this.copyTopic = new Topic(null, null, null, true, true);
+        this.buildTopic(new Topic(null, null, null, true, true, false));
       } else {
-        this.copyTopic = HelperFunctions.copy(this.stakeholder.topics[index]);
+        this.buildTopic(this.stakeholder.topics[index]);
       }
       this.show(element);
     }
@@ -100,9 +113,9 @@
   }
 
   public saveTopic(element, index = -1) {
-    if (this.copyTopic.name && this.copyTopic.name !== '') {
-      if (!this.copyTopic.alias) {
-        this.copyTopic.alias = this.copyTopic.name.toLowerCase().trim();
+    if (!this.topicFb.invalid) {
+      if (!this.topicFb.value.alias) {
+        this.topicFb.value.alias = this.topicFb.value.name.toLowerCase().trim();
       }
       if (index === -1) {
         this.save('Topic has been successfully created', element);
@@ -109,8 +122,6 @@
       } else {
         this.save('Topic has been successfully saved', element, index);
       }
-    } else {
-      this.valid = false;
     }
   }
 
@@ -126,7 +137,7 @@
 
   private save(message: string, element, index: number = -1) {
     let path = [this.stakeholder._id];
-    this.stakeholderService.saveElement(this.properties.monitorServiceAPIURL, this.copyTopic, path).subscribe(topic => {
+    this.stakeholderService.saveElement(this.properties.monitorServiceAPIURL, this.topicFb.value, path).subscribe(topic => {
       if (index === -1) {
         this.stakeholder.topics.push(topic);
       } else {
@@ -135,7 +146,7 @@
       this.stakeholderService.setStakeholder(this.stakeholder);
       UIkit.notification(message, {
         status: 'success',
-        timeout: 3000,
+        timeout: 3000000,
         pos: 'top-left'
       });
       this.hide(element);
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/utils/entities/stakeholder.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/utils/entities/stakeholder.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/utils/entities/stakeholder.ts	(revision 57697)
@@ -290,7 +290,7 @@
   isDefault: boolean;
   categories: Category[];
 
-  constructor(name: string, description: string, alias: string, isActive: boolean, isPublic: boolean) {
+  constructor(name: string, description: string, alias: string, isActive: boolean, isPublic: boolean, isDefault: boolean = true) {
     this._id = null;
     this.name = name;
     this.description = description;
@@ -297,6 +297,7 @@
     this.alias = alias;
     this.isActive = isActive;
     this.isPublic = isPublic;
+    this.isDefault = isDefault;
     this.categories = [];
   }
 }
@@ -312,7 +313,7 @@
   isDefault: boolean;
   subCategories: SubCategory[];
 
-  constructor(name: string, description: string, alias: string, isActive: boolean, isPublic: boolean) {
+  constructor(name: string, description: string, alias: string, isActive: boolean, isPublic: boolean, isDefault: boolean = true) {
     this._id = null;
     this.name = name;
     this.description = description;
@@ -319,6 +320,7 @@
     this.alias = alias;
     this.isActive = isActive;
     this.isPublic = isPublic;
+    this.isDefault = isDefault;
     this.subCategories = [];
   }
 }
@@ -334,7 +336,7 @@
   charts: Indicator[];
   numbers: Indicator[];
 
-  constructor(name: string, description: string, alias: string, isActive: boolean, isPublic: boolean) {
+  constructor(name: string, description: string, alias: string, isActive: boolean, isPublic: boolean, isDefault: boolean = true) {
     this._id = null;
     this.name = name;
     this.description = description;
@@ -341,6 +343,7 @@
     this.alias = alias;
     this.isActive = isActive;
     this.isPublic = isPublic;
+    this.isDefault = isDefault;
     this.charts = [];
     this.numbers = [];
   }
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/library/sharedComponents/input/input.component.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/library/sharedComponents/input/input.component.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/library/sharedComponents/input/input.component.ts	(revision 57697)
@@ -1,34 +1,24 @@
 import {Component, Input, OnDestroy, OnInit} from "@angular/core";
 import {Option} from "../../../utils/indicator-utils";
+import {AbstractControl, FormControl} from "@angular/forms";
 
 @Component({
   selector: '[dashboard-input]',
   template: `
-    <div class="md-input-wrapper"
-         [class.md-input-filled]="formControl.value !== ''"
-         [class.md-input-focus]="formControl.touched"
-         [class.md-input-wrapper-danger]="formControl.invalid && formControl.dirty">
-      <label>{{label}}</label>
-      <input *ngIf="type === 'text' || type === 'number'" [type]="type" class="md-input"
-             focus-directive [formInput]="formControl"
-             [formControl]="formControl"
-             [class.md-input-danger]="formControl.invalid && formControl.dirty">
-      <textarea *ngIf="type === 'textarea'" type="text" class="md-input no_autosize"
-                focus-directive [formInput]="formControl"
-                [rows]="rows" [formControl]="formControl"></textarea>
-      <span class="md-input-bar"></span>
-      <select *ngIf="type === 'select'" class="md-input uk-select"
-             focus-directive [formInput]="formControl"
-             [formControl]="formControl"
-             [class.md-input-danger]="formControl.invalid && formControl.dirty">
-        <option [value]="option.value" *ngFor="let option of options">
+    <mat-form-field class="uk-width-1-1 uk-padding-remove">
+      <input *ngIf="type === 'text'" matInput [placeholder]="label"
+             [formControl]="formControl" [required]="required">
+      <textarea *ngIf="type === 'textarea'" [rows]="rows" matInput [placeholder]="label" [formControl]="formControl"></textarea>
+      <mat-select *ngIf="type === 'select'" [placeholder]="label"  [formControl]="formControl" [disableOptionCentering]="true">
+        <mat-option *ngFor="let option of options" [value]="option.value">
           {{option.label}}
-        </option>
-      </select>
-    </div>`
+        </mat-option>
+      </mat-select>
+    </mat-form-field>
+  `
 })
 export class InputComponent implements OnInit, OnDestroy {
-  @Input('formInput') formControl: any;
+  @Input('formInput') formControl: FormControl;
   @Input('type') type: string = 'text';
   @Input('label') label: string;
   @Input('rows') rows: number = 3;
@@ -42,4 +32,10 @@
 
   ngOnDestroy(): void {
   }
+
+  public get required(): boolean {
+    return this.formControl && this.formControl.validator
+      && this.formControl.validator(this.formControl)
+      && this.formControl.validator(this.formControl).required;
+  }
 }
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/library/sharedComponents/input/input.module.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/library/sharedComponents/input/input.module.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/library/sharedComponents/input/input.module.ts	(revision 57697)
@@ -3,11 +3,17 @@
 import {FocusDirective} from "./focus.directive";
 import {InputComponent} from "./input.component";
 import {SharedModule} from "../../../shared/shared.module";
+import {MatFormFieldModule} from "@angular/material/form-field";
+import {MatInputModule} from "@angular/material/input";
+import {MatSelectModule} from "@angular/material/select";
 
 @NgModule({
   imports: [
     CommonModule,
     SharedModule,
+    MatFormFieldModule,
+    MatInputModule,
+    MatSelectModule,
   ],
   exports: [
     InputComponent
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/app.component.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/app.component.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/app.component.ts	(revision 57697)
@@ -19,7 +19,7 @@
   user: User;
   loginCheck: boolean = false;
   hasSidebar: boolean = false;
-  public subscriptions: any[] = [];
+  private subscriptions: any[] = [];
 
   constructor(private  route: ActivatedRoute,
               private propertiesService: EnvironmentSpecificService,
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/topic/topic.component.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/topic/topic.component.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/topic/topic.component.ts	(revision 57697)
@@ -8,6 +8,7 @@
 import {HelperFunctions} from "../openaireLibrary/utils/HelperFunctions.class";
 import {AlertModal} from "../openaireLibrary/utils/modal/alert";
 import {Subscriber} from "rxjs";
+import {FormBuilder, FormGroup, Validators} from "@angular/forms";
 
 declare var UIkit;
 
@@ -24,7 +25,7 @@
    * Current topic
    **/
   public topicIndex: number = 0;
-  public topic: Topic = null;
+  public topicFb: FormGroup;
 
   /**
    * categoryIndex: Current category to be edited, selectedCategoryIndex: selected on menu(opened)
@@ -31,12 +32,12 @@
    */
   public categoryIndex: number = 0;
   public selectedCategoryIndex: number = 0;
-  public copyCategory: Category = null;
+  public categoryFb: FormGroup;
   /**
    * Current Subcategory to be edited
    */
   public subCategoryIndex: number = 0;
-  public copySubCategory: SubCategory = null;
+  public subcategoryFb: FormGroup;
   /**
    * Current drop element and index of topic, category or subcategory to be deleted.
    */
@@ -45,7 +46,6 @@
   /**
    * Check form validity
    */
-  public valid = true;
   public toggle: boolean = false;
 
   @ViewChild('deleteTopicModal') deleteTopicModal: AlertModal;
@@ -56,6 +56,7 @@
     private route: ActivatedRoute,
     private router: Router,
     private title: Title,
+    private fb: FormBuilder,
     private sideBarService: SideBarService,
     private stakeholderService: StakeholderService) {
   }
@@ -90,7 +91,6 @@
   }
 
   public hide(element) {
-    this.valid = true;
     UIkit.drop(element).hide();
   }
 
@@ -98,19 +98,32 @@
     UIkit.drop(element).show();
   }
 
+  private buildTopic(topic: Topic) {
+    this.topicFb = this.fb.group({
+      _id: this.fb.control(topic._id),
+      name: this.fb.control(topic.name, Validators.required),
+      description: this.fb.control(topic.description),
+      alias: this.fb.control(topic.alias),
+      isActive: this.fb.control(topic.isActive),
+      isPublic: this.fb.control(topic.isPublic),
+      isDefault: this.fb.control(topic.isDefault),
+      categories: this.fb.control(topic.categories)
+    });
+  }
+
   public editTopicOpen(element) {
     if(element.className.indexOf('uk-open') !== -1) {
       this.hide(element);
     } else {
-      this.topic = HelperFunctions.copy(this.stakeholder.topics[this.topicIndex]);
+      this.buildTopic(this.stakeholder.topics[this.topicIndex]);
       this.show(element);
     }
   }
 
   public saveTopic(element) {
-    if(this.topic.name && this.topic.name !== '') {
-      if(!this.topic.alias) {
-        this.topic.alias = this.topic.name.toLowerCase().trim();
+    if(!this.topicFb.invalid) {
+      if(!this.topicFb.value.alias) {
+        this.topicFb.value.alias = this.topicFb.value.name.toLowerCase().trim();
       }
       let path = [this.stakeholder._id];
       let callback = (topic: Topic): void => {
@@ -117,9 +130,7 @@
           this.stakeholder.topics[this.topicIndex] = topic;
           this.stakeholderService.setStakeholder(this.stakeholder);
       };
-      this.save('Topic has been successfully saved', element, path, this.topic, callback,true);
-    } else {
-      this.valid = false;
+      this.save('Topic has been successfully saved', element, path, this.topicFb.value, callback,true);
     }
   }
 
@@ -148,14 +159,26 @@
     }
   }
 
+  private buildCategory(category: Category) {
+    this.categoryFb = this.fb.group({
+      _id: this.fb.control(category._id),
+      name: this.fb.control(category.name, Validators.required),
+      alias: this.fb.control(category.alias),
+      isActive: this.fb.control(category.isActive),
+      isPublic: this.fb.control(category.isPublic),
+      isDefault: this.fb.control(category.isDefault),
+      subCategories: this.fb.control(category.subCategories)
+    });
+  }
+
   public editCategoryOpen(element, index:number = -1) {
     if(element.className.indexOf('uk-open') !== -1) {
       this.hide(element);
     } else {
       if(index === -1) {
-        this.copyCategory = new Category(null, null, null, true, true);
+        this.buildCategory(new Category(null, null, null, true, true));
       } else {
-        this.copyCategory = HelperFunctions.copy(this.stakeholder.topics[this.topicIndex].categories[index]);
+        this.buildCategory(this.stakeholder.topics[this.topicIndex].categories[index]);
       }
       this.show(element);
     }
@@ -162,9 +185,9 @@
   }
 
   public saveCategory(element, index = -1) {
-    if(this.copyCategory.name && this.copyCategory.name !== '') {
-      if(!this.copyCategory.alias) {
-        this.copyCategory.alias = this.copyCategory.name.toLowerCase();
+    if(!this.categoryFb.invalid) {
+      if(!this.categoryFb.value.alias) {
+        this.categoryFb.value.alias = this.categoryFb.value.name.toLowerCase();
       }
       let path = [this.stakeholder._id, this.stakeholder.topics[this.topicIndex]._id];
       let callback = (category: Category): void => {
@@ -176,12 +199,10 @@
         this.stakeholderService.setStakeholder(this.stakeholder);
       };
       if(index === -1) {
-        this.save('Category has been successfully created', element, path, this.copyCategory, callback);
+        this.save('Category has been successfully created', element, path, this.categoryFb.value, callback);
       } else {
-        this.save('Category has been successfully saved', element, path, this.copyCategory, callback);
+        this.save('Category has been successfully saved', element, path, this.categoryFb.value, callback);
       }
-    } else {
-      this.valid = false;
     }
   }
 
@@ -202,15 +223,28 @@
     this.delete('Category has been successfully be deleted', path, callback);
   }
 
+  private buildSubcategory(subCategory: SubCategory) {
+    this.subcategoryFb = this.fb.group({
+      _id: this.fb.control(subCategory._id),
+      name: this.fb.control(subCategory.name, Validators.required),
+      alias: this.fb.control(subCategory.alias),
+      isActive: this.fb.control(subCategory.isActive),
+      isPublic: this.fb.control(subCategory.isPublic),
+      isDefault: this.fb.control(subCategory.isDefault),
+      charts: this.fb.control(subCategory.charts),
+      numbers: this.fb.control(subCategory.numbers)
+    });
+  }
+
   public editSubCategoryOpen(element, index:number = -1) {
     if(element.className.indexOf('uk-open') !== -1) {
       this.hide(element);
     } else {
       if(index === -1) {
-        this.copySubCategory = new SubCategory(null, null, null, true, true);
+        this.buildSubcategory(new SubCategory(null, null, null, true, true));
       } else {
-        this.copySubCategory = HelperFunctions.copy(this.stakeholder.topics[this.topicIndex].
-          categories[this.categoryIndex].subCategories[index]);
+        this.buildSubcategory(this.stakeholder.topics[this.topicIndex].
+          categories[this.selectedCategoryIndex].subCategories[index]);
       }
       this.show(element);
     }
@@ -217,9 +251,9 @@
   }
 
   public saveSubCategory(element, index = -1) {
-    if(this.copySubCategory.name && this.copySubCategory.name !== '') {
-      if(!this.copySubCategory.alias) {
-        this.copySubCategory.alias = this.copySubCategory.name.toLowerCase();
+    if(!this.subcategoryFb.invalid) {
+      if(!this.subcategoryFb.value.alias) {
+        this.subcategoryFb.value.alias = this.subcategoryFb.value.name.toLowerCase();
       }
       let path: string[] = [
         this.stakeholder._id,
@@ -237,13 +271,11 @@
         this.stakeholderService.setStakeholder(this.stakeholder);
       };
       if(index === -1) {
-        this.save('Subcategory has been successfully created', element, path, this.copySubCategory, callback);
+        this.save('Subcategory has been successfully created', element, path, this.subcategoryFb.value, callback);
       } else {
-        this.save('Subcategory has been successfully saved', element, path, this.copySubCategory, callback);
+        this.save('Subcategory has been successfully saved', element, path, this.subcategoryFb.value, callback);
       }
       this.hide(element);
-    } else {
-      this.valid = false;
     }
   }
 
Index: modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/topic/indicators.component.ts
===================================================================
--- modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/topic/indicators.component.ts	(revision 57696)
+++ modules/uoa-monitor-portal/trunk/monitor_dashboard/src/app/topic/indicators.component.ts	(revision 57697)
@@ -1,7 +1,7 @@
-import {AfterViewInit, Component, Input, OnChanges, OnInit, SimpleChanges, ViewChild} from "@angular/core";
+import {AfterViewInit, Component, Input, OnChanges, OnDestroy, OnInit, SimpleChanges, ViewChild} from "@angular/core";
 import {SideBarService} from "../library/sharedComponents/sidebar/sideBar.service";
 import {Indicator, IndicatorPath, Stakeholder} from "../utils/entities/stakeholder";
-import {IndicatorUtils} from "../utils/indicator-utils";
+import {IndicatorUtils, Option} from "../utils/indicator-utils";
 import {FormArray, FormBuilder, FormControl, FormGroup, Validators} from "@angular/forms";
 import {AlertModal} from "../openaireLibrary/utils/modal/alert";
 import {StatisticsService} from "../utils/services/statistics.service";
@@ -9,6 +9,7 @@
 import {DomSanitizer} from "@angular/platform-browser";
 import {StakeholderService} from "../services/stakeholder.service";
 import {EnvProperties} from "../openaireLibrary/utils/properties/env-properties";
+import {Subscriber} from "rxjs";
 
 declare var UIkit;
 
@@ -16,7 +17,7 @@
   selector: 'indicators',
   templateUrl: './indicators.component.html'
 })
-export class IndicatorsComponent implements OnInit, OnChanges {
+export class IndicatorsComponent implements OnInit, OnDestroy, OnChanges, AfterViewInit {
 
   @Input()
   public properties: EnvProperties = null;
@@ -44,17 +45,20 @@
   /**
    * Top filters
    */
-  public chartType: string = 'all';
-  public privacy: string = 'all';
-  public status: string = 'all';
-  public keyword: string = null;
+  public filters: FormGroup;
+  public all: Option = {
+    value: 'all',
+    label: 'All'
+  };
   /**
    * Grid or List View
    */
   public grid: boolean = true;
+  private subscriptions: any[] = [];
 
   @ViewChild('createIndicatorModal') createIndicatorModal: AlertModal;
   @ViewChild('editIndicatorModal') editIndicatorModal: AlertModal;
+  @ViewChild('deleteIndicatorModal') deleteIndicatorModal: AlertModal;
 
   constructor(private sideBarService: SideBarService,
               private stakeholderService: StakeholderService,
@@ -64,35 +68,39 @@
   }
 
   ngOnInit(): void {
+    this.buildFilters();
+  }
+
+  ngOnDestroy(): void {
+    this.subscriptions.forEach(value => {
+      if (value instanceof Subscriber) {
+        value.unsubscribe();
+      } else if(value instanceof Function){
+        value();
+      }
+    });
+  }
+
+  ngAfterViewInit(): void {
     if (document !== undefined) {
       let callback = (list): void => {
         let items: HTMLCollection = list.current.children;
         let reordered = [];
-        let indicators = [];
         for (let i = 0; i < items.length; i++) {
           if (items.item(i).id) {
-            reordered.push(+items.item(i).id);
+            reordered.push(items.item(i).id);
           }
         }
-        if(list.current.id === 'charts') {
-          reordered.forEach((id, index) => {
-            indicators[index] = HelperFunctions.copy(this.charts[id]);
-          });
-          this.reorderIndicators('chart', indicators);
-        } else if(list.current.id === 'numbers') {
-          reordered.forEach((id, index) => {
-            indicators[index] = HelperFunctions.copy(this.numbers[id]);
-          });
-          this.reorderIndicators('number', indicators);
-        }
+        this.reorderIndicators(list.current.id , reordered);
       };
-      UIkit.util.on(document, 'moved', '#charts', callback);
-      UIkit.util.on(document, 'moved', '#numbers', callback);
+      this.subscriptions.push(UIkit.util.on(document, 'moved', '#chart', callback));
+      this.subscriptions.push(UIkit.util.on(document, 'moved', '#number', callback));
     }
   }
 
   ngOnChanges(changes: SimpleChanges): void {
     if (this.canEdit) {
+      this.buildFilters();
       this.filterCharts();
       this.filterNumbers();
     }
@@ -110,19 +118,41 @@
     this.grid = value;
   }
 
+  private buildFilters() {
+    this.filters = this.fb.group({
+      chartType: this.fb.control('all'),
+      privacy: this.fb.control('all'),
+      status: this.fb.control('all'),
+      keyword: this.fb.control('')
+    });
+    this.subscriptions.push(this.filters.get('chartType').valueChanges.subscribe( value => {
+      this.onChartTypeChange(value);
+    }));
+    this.subscriptions.push(this.filters.get('privacy').valueChanges.subscribe( value => {
+      this.onPrivacyChange(value);
+    }));
+    this.subscriptions.push(this.filters.get('status').valueChanges.subscribe( value => {
+      this.onStatusChange(value);
+    }));
+    this.subscriptions.push(this.filters.get('keyword').valueChanges.subscribe( value => {
+      this.onKeywordChange(value);
+    }));
+  }
+
   filterCharts() {
     this.displayCharts = this.filterChartType(this.filterPrivacy(
-      this.filterStatus(this.filterByKeyword(this.charts, this.keyword), this.status),
-      this.privacy),
-      this.chartType
+      this.filterStatus(this.filterByKeyword(this.charts, this.filters.value.keyword),
+        this.filters.value.status),
+      this.filters.value.privacy),
+      this.filters.value.chartType
     );
   }
 
   filterNumbers() {
     this.displayNumbers = this.filterPrivacy(this.filterStatus(
-      this.filterByKeyword(this.numbers, this.keyword),
-      this.status),
-      this.privacy);
+      this.filterByKeyword(this.numbers, this.filters.value.keyword),
+      this.filters.value.status),
+      this.filters.value.privacy);
   }
 
   onChartTypeChange(value) {
@@ -130,6 +160,7 @@
   }
 
   onPrivacyChange(value) {
+    console.log(value);
     this.displayCharts = this.filterPrivacy(this.charts, value);
     this.displayNumbers = this.filterPrivacy(this.numbers, value);
   }
@@ -157,7 +188,7 @@
     if (value === 'all') {
       return indicators;
     } else {
-      return indicators.filter(indicator => indicator.isPublic === (value === 'public'));
+      return indicators.filter(indicator => indicator.isPublic === value);
     }
   }
 
@@ -165,7 +196,7 @@
     if (value === 'all') {
       return indicators;
     } else {
-      return indicators.filter(indicator => indicator.isActive === (value === 'active'));
+      return indicators.filter(indicator => indicator.isActive === value);
     }
   }
 
@@ -173,8 +204,8 @@
     if (value === null || value === '') {
       return indicators;
     } else {
-      return indicators.filter(indicator => (indicator.name && indicator.name.includes(value))
-        || (indicator.description && indicator.description.includes(value)));
+      return indicators.filter(indicator => (indicator.name && indicator.name.toLowerCase().includes(value.toLowerCase()))
+        || (indicator.description && indicator.description.toLowerCase().includes(value.toLowerCase())));
     }
   }
 
@@ -322,7 +353,7 @@
       this.indicator.indicatorPaths.forEach(indicatorPath => {
         indicatorPath.safeResourceUrl = this.getUrlByStakeHolder(indicatorPath)
       });
-    }, 500);
+    }, (index === -1)?500:0);
   }
 
   saveIndicator() {
@@ -344,7 +375,7 @@
     });
   }
 
-  reorderIndicators(type: string, indicators: Indicator[]) {
+  reorderIndicators(type: string, indicatorIds: string[]) {
     let path = [
       this.stakeholder._id,
       this.stakeholder.topics[this.topicIndex]._id,
@@ -351,9 +382,8 @@
       this.stakeholder.topics[this.topicIndex].categories[this.categoryIndex]._id,
       this.stakeholder.topics[this.topicIndex].categories[this.categoryIndex].subCategories[this.subcategoryIndex]._id
     ];
-    this.stakeholderService.reorderIndicators(this.properties.monitorServiceAPIURL, path, indicators, type).
-    subscribe(() => {
-      if(type === 'chart') {
+    this.stakeholderService.reorderIndicators(this.properties.monitorServiceAPIURL, path, indicatorIds, type).subscribe(indicators => {
+      if (type === 'chart') {
         this.charts = indicators;
         this.filterCharts();
       } else {
@@ -371,4 +401,36 @@
     });
     this.indicatorPaths.at(index).markAsPristine({onlySelf: true});
   }
+
+  deleteIndicatorOpen(index: number, type: string = 'chart') {
+    this.index = index;
+    if(type === 'chart') {
+      this.indicator = this.charts[index];
+    } else {
+      this.indicator = this.numbers[index];
+    }
+    this.deleteIndicatorModal.alertTitle = 'Delete ' + this.indicator.name;
+    this.deleteIndicatorModal.cancelButtonText = 'No';
+    this.deleteIndicatorModal.okButtonText = 'Yes';
+    this.deleteIndicatorModal.message = 'This indicator will permanently be deleted. Are you sure you want to proceed?';
+    this.deleteIndicatorModal.open();
+  }
+
+  deleteIndicator() {
+    let path = [
+      this.stakeholder._id,
+      this.stakeholder.topics[this.topicIndex]._id,
+      this.stakeholder.topics[this.topicIndex].categories[this.categoryIndex]._id,
+      this.stakeholder.topics[this.topicIndex].categories[this.categoryIndex].subCategories[this.subcategoryIndex]._id,
+      this.indicator._id
+    ];
+    this.stakeholderService.deleteElement(this.properties.monitorServiceAPIURL, path).subscribe( () => {
+      if(this.indicator.type === 'chart') {
+        this.charts.splice(this.index, 1);
+      } else {
+        this.numbers.splice(this.index, 1);
+      }
+      this.stakeholderService.setStakeholder(this.stakeholder);
+    });
+  }
 }
